module particleMod

integer, parameter :: DOUBLE = kind(1.0d0)

type particle
  real(DOUBLE) :: position(3)
  real(DOUBLE) :: velocity(3)
  real(DOUBLE) :: mass
end type particle

contains

subroutine particleCreate(this, position, velocity)
  type(particle), intent(inout) :: this
  real(DOUBLE), pointer :: position(:), velocity(:)
  integer :: i

  do i = 1, 3
    this%position(i) = position(i)
    this%velocity(i) = velocity(i)
  end do
end subroutine particleCreate

subroutine particleMove(this, timeStep)
  type(particle) :: this
  real(DOUBLE) :: timeStep
  integer :: i
  do i = 1, 3
    this%position(i) = this%position(i) + this%velocity(i) * timeStep
  end do
end subroutine particleMove

subroutine particlePrint(this)
  type(particle) :: this
  do i = 1, 3
    print *, "[", i, "]: position =", this%position(i), "  velocity =", this%velocity(i)
  end do
end subroutine particlePrint

end module
